package guess;

import java.io.IOException;
import javax.inject.Inject;
import javax.websocket.CloseReason;
import javax.websocket.EndpointConfig;
import javax.websocket.OnClose;
import javax.websocket.OnMessage;
import javax.websocket.OnOpen;
import javax.websocket.Session;
import javax.websocket.server.ServerEndpoint;


@ServerEndpoint("/guessnotify")
public class GameOverNotifier {

    @Inject
    Userguess userguess;
    
    @Inject
    Guess guess;
    
    private Session mySession;
    
    @OnOpen
    public void open(Session session, EndpointConfig conf) 
    { 
        mySession = session;
        guess.addUser();
        userguess.setNotifier(this);
        announce(1, guess.getNumberOfUsers());
    }
    
    @OnClose
    public void close(Session session, CloseReason reason) 
    {
        guess.removeUser();
        announce(1, guess.getNumberOfUsers());
    }
    
    @OnMessage
    public String onMessage(String message) {
        return null;
    }
    
    public void announce(int num, String msg)
    {
        String fullMsg = Integer.toString(num) + ";" + msg;
        try {            
         for (Session sess : mySession.getOpenSessions()) {
            if (sess.isOpen())
               sess.getBasicRemote().sendText(fullMsg);
         }
      } catch (IOException e) { }
    }
}
