package guess;

import java.util.Random;
import javax.inject.Named;
import javax.enterprise.context.ApplicationScoped;

@Named(value = "guess")
@ApplicationScoped
public class Guess {

    private int guessedNumber;
    Random rnd;
    private boolean alreadyGuessed;
    private int numberOfUsers;

    public String getNumberOfUsers() {
        return Integer.toString(numberOfUsers);
    }

    public void setNumberOfUsers(String numberOfUsers) {
        this.numberOfUsers = Integer.parseInt(numberOfUsers);
    }
    
    public Guess() {
        rnd = new Random();
        restart();
        numberOfUsers = 0;
    }
 
    void restart()
    {
        guessedNumber = rnd.nextInt(10) + 1;
        alreadyGuessed = false;
    }

    public synchronized boolean getAndSetAlreadyGuessed() {
        boolean wasAlreadyGuessed = alreadyGuessed;
        alreadyGuessed = true;
        return wasAlreadyGuessed;
    }
    
    public int getGuessedNumber()
    {
        return guessedNumber;
    }
    
    public synchronized void addUser()
    {
        numberOfUsers++;
    }
    
    public synchronized void removeUser()
    {
        numberOfUsers--;
    }
}
